#include <ncurses.h>

#define MAXCHAN 48
#define MAXWATCH 32
#define VERSION "0.5b2"

struct config {
    char color;
    char clock;
    char border;
    char topspace;
    char alarm1;
    char alarm2;
    char extalarm1[256];
    char extalarm2[256];
    
    char maxhits;
    
    char forking;
    char tty[32];
    
    char watch[MAXWATCH][32]; 
};
    
struct config conf;

struct kanal {
    char used; /* set 1 if filled with data */
    char file[32];
    char name[32]; /* channel name */
    char program[MAXCHAN+1][32]; /* no more strlen than 31 */
    int watch[MAXCHAN+1];
    int starttid[MAXCHAN+1]; /* time from 00:00 in minutes untill programstart */
};

struct kanal kanaler[16]; /* 16 channels, enough? */

struct prgtable {
   char channel[32];
   char program[32];
   int starttid;
};

WINDOW *win_watch;
WINDOW *win_tw;
WINDOW *win_find;
WINDOW *win_list;

int max_x,max_y;

/* curses.c */
void print_time(int maxx);
void print_channels(void);
void init_curses(void);
void init_colors(void);
void kill_curses(void);
void print_curr_prgms(int chann);
void special_print(int chann);
void actual_print(int chann, int i);
void print_all();
void check_resize();
void print_border(void);
void edit_tvconf(void);
void termcap_info(void);
int compare_func(const void *a, const void *b);

WINDOW *print_reload_win(void);
WINDOW *print_watch_win(void);
WINDOW *print_todays_watch(void); 
WINDOW *kill_win(WINDOW *killwin);
WINDOW *find_program(void);
WINDOW *list_channel(void);
void show_channel_listing(int channel);
WINDOW *error_win(char *msg);

/* lists.c */
void parse_data(char *p);
void strip_cpcr(char *buf);
int reload(int bootup);
int filldata(char *file);
void printdata(void);
void printwatch(void);
void initdata(void);
int findfreewatch(void);
int findfreekanal(void);
void flag_watches(int num);
void delete_watch_from_cfg(const char *str);
void unflag_watch(const char *str);
void flag_watch(const char *str);
void add_watch(const char *str);
int count_watches(void);

/* alarm.c */
void check_watches(int min);
char *parse_extalarm(const char *exta, int i, int j, char *output);
void do_alarms(int alarmnum, int i, int j);

